import itertools
import random

from naja.gen_sound import Chunk, scale


def grind():
    yield Chunk('sine', freq=200, length=0.01, volume=25)
    tones = []
    for freq in (200, 300, 400, 700, 240, 340, 600):
        tones.append(Chunk('sine', freq=freq, length=0.005, volume=25))
    for i in range(75):
        yield random.choice(tones)
    yield Chunk('sine', freq=200, length=0.01, volume=25)


SOUNDS = {
    'chirp': scale(1650, 1449, -200, length=0.05, volume=50),
    'error': Chunk('sine', freq=1000, length=0.25),
    'grind': grind(),
    'shutdown': scale(1600, 399, -400, length=0.1),
    'silence': Chunk('silence', length=2),
    'startup': scale(400, 1601, 400, length=0.1),
    'zoop': scale(1000, 1600, 40, length=0.005, volume=50),
    'zzzzz': Chunk('sine', freq=200, length=0.25, volume=50),
    'yipee': itertools.chain(
        scale(1400, 1801, 100, length=0.05, volume=50),
        scale(1600, 1801, 100, length=0.05, volume=50),
    ),
    'awwww': (
        Chunk('sine', freq=800, length=0.1, volume=50),
        Chunk('sine', freq=500, length=0.2, volume=50),
    ),
    'aha': (
        Chunk('sine', freq=2000, length=0.1, volume=50),
        Chunk('sine', freq=2200, length=0.05, volume=50),
    ),
}
