"""
Lose scene.
"""

import pygame.locals as pgl

from naja.constants import KEYS, PALETTE
from naja.scenes.scene import Scene
from naja.sound import sound
from naja.widgets.image_box import ImageBox
from naja.widgets.text import TextWidget, TextBoxWidget
from naja.events import SceneChangeEvent, LoadGameEvent


class LoseScene(Scene):
    """
    Commiserations.
    """

    def __init__(self, state):
        super(LoseScene, self).__init__(state)

        background = ImageBox(
            (0, 0), "screens/you_lost.png")
        self.add(background)

        y_offset = 250

        if self.state.gameboard.has_cheated:
            self.add(TextWidget(
                (50, y_offset), 'Even with cheats on.', colour=PALETTE.ORANGE))
            y_offset += 50

        self.add(TextBoxWidget(
            (50, y_offset), '\n\n'.join([
                "Something went terribly wrong.",
                "You should re-evaluate your life choices.",
                "Press ESC to return to the menu",
            ]), fontsize=32,
            colour='white', padding=1, border=1,
            bg_colour='black', border_colour='black',
            box_width=300))
        sound.play_music('lost.ogg', 0.25)

    def handle_scene_event(self, ev):
        from naja.scenes.menu import MenuScene
        if ev.type == pgl.KEYDOWN and ev.key in KEYS.QUIT:
            sound.stop()
            # drop current state
            LoadGameEvent.post(None)
            SceneChangeEvent.post(MenuScene)
            return
