"""
Base Scene class.
"""

from naja.widgets.base import Container


class Scene(object):
    """
    A scene within the game.

    E.g. Splash screen, game board, credits, win, lose.
    """
    def __init__(self, state):
        self.state = state
        self.container = Container()

    def add(self, widget):
        self.container.add(widget)

    def enter(self):
        pass

    def exit(self):
        pass

    def render_scene(self, surface):
        pass

    def render(self, surface):
        self.render_scene(surface)
        self.container.render(surface)

    def handle_event(self, ev):
        if self.container.handle_event(ev):
            return
        self.handle_scene_event(ev)

    def handle_scene_event(ev):
        pass
