from unittest import TestCase

import pygame

from naja.utils import convert_colour, parse_bits
from naja.constants import BITS


class TestConvertColour(TestCase):
    def setUp(self):
        self.red = pygame.Color('red')

    def test_pass_through(self):
        self.assertEqual(self.red, convert_colour(self.red))

    def test_tuple(self):
        self.assertEqual(self.red, convert_colour((255, 0, 0)))

    def test_string(self):
        self.assertEqual(self.red, convert_colour('red'))


class TestParseBits(TestCase):
    def test_parse_bits(self):
        self.assertEqual(parse_bits([]), frozenset([]))
        self.assertEqual(parse_bits(['RED']), frozenset([BITS.RED]))
        self.assertEqual(parse_bits([BITS.BLUE]), frozenset([BITS.BLUE]))
        self.assertEqual(
            parse_bits([BITS.NORTH, 'MSB']), frozenset([BITS.NORTH, BITS.MSB]))
