"""Widget to draw the player on the screen"""

from naja.constants import (PLAYER_SIZE, BIT_SIZE, TILE_SIZE, BITS)
from naja.resources import resources
from naja.resources.mutators import EIGHT_BIT
from naja.widgets.base import Widget

IMG_MAP = {
    BITS.MSB: 'board/robot_msb.png',
    BITS.RED: 'board/robot_red.png',
    BITS.GREEN: 'board/robot_green.png',
    BITS.BLUE: 'board/robot_blue.png',
}


class RobotWidget(Widget):
    """Widget which holds a tile on the game board."""
    def __init__(self, state):
        pos = (state.player.position[0] * TILE_SIZE[0],
               state.player.position[1] * TILE_SIZE[1] + BIT_SIZE[1])
        super(RobotWidget, self).__init__(pos, PLAYER_SIZE)
        self.state = state

    def prepare(self):
        # Look up the required bits on the board location
        self.pos = (self.state.player.position[0] * TILE_SIZE[0],
                    self.state.player.position[1] * TILE_SIZE[1] + BIT_SIZE[1])
        self.surface = resources.get_image('board/robot.png',
                                           transforms=(EIGHT_BIT,)).copy()
        for bit, img_name in IMG_MAP.iteritems():
            if self.state.player.bits.check_bit(bit):
                bit_img = resources.get_image(img_name,
                                              transforms=(EIGHT_BIT,))
                self.surface.blit(bit_img, (0, 0))

    def draw(self, surface):
        surface.blit(self.surface, self.rect)
