#!/usr/bin/env python

from subprocess import Popen, PIPE
import os
import sys


def gen_raw(description):
    for chunk in description:
        for blob in chunk.raw():
            yield blob


def encode(filename, data):
    print "Writing %s" % filename
    p = Popen(('oggenc', '-o', filename, '--raw', '--raw-chan=1',
               '--quiet', '-'),
              stdin=PIPE, cwd='data/sounds')
    for blob in data:
        p.stdin.write(blob)
    p.stdin.close()
    assert p.wait() == 0


def write(basename, description):
    return encode('%s.ogg' % basename, gen_raw(description))


def main():
    sys.path.insert(0, os.path.join(os.path.dirname(__file__), '..'))
    from data.sounds import SOUNDS
    from naja.gen_sound import Chunk

    sounds = SOUNDS.keys()
    if len(sys.argv) > 1:
        sounds = sys.argv[1:]
    for sound in sounds:
        description = SOUNDS[sound]
        if isinstance(description, Chunk):
            description = (description,)
        write(sound, description)


if __name__ == '__main__':
    main()
